OPT MODULE
OPT EXPORT

MODULE  'asl',
        'libraries/asl',
        '*mv_consts'

DEF req : PTR TO filerequester

->  Procedura zwracajca pen nazw pliku
->  IN :
->    drawer   -> katalog
->    file     -> nazwa pliku
->  OUT :
->    fullname -> pena nazwa (rozwinite assigny)
->

PROC get_fullname(drawer : PTR TO CHAR,file : PTR TO CHAR)

DEF fullname[256] : STRING,
    pathlock,
    success

  pathlock := Lock(drawer,OLDFILE)
  success := NameFromLock(pathlock,fullname,256)
  AddPart(fullname,file,256)

ENDPROC fullname

->  Procedura pobierajca plik via ASL filerequeester
->  IN :
->      titletext   -> Tekst na belk okna
->      pubscreen   -> nazwa ekranu na ktrym ma si otworzy (DEFAULT NIL)
->  OUT :
->      success     -> wybra co z requestera
->
->  Dostp DO pl struktury filerequester jest via globalna zmienna req
->

PROC file_req(titletext : PTR TO CHAR, pubscreen = NIL)

  IF (aslbase := OpenLibrary('asl.library',38)) = NIL THEN Raise(ERR_NO_ASL)

  req := AllocAslRequest(ASL_FILEREQUEST,
                        [ASLFR_TITLETEXT,    titletext,
                         ASLFR_PUBSCREENNAME,pubscreen,
                         ASLFR_DOPATTERNS,   TRUE,
                         ASLFR_DOMULTISELECT,TRUE,
                         NIL])

  IF req = NIL THEN Raise(ERR_ALLOC)

  IF AslRequest(req,NIL)
    RETURN TRUE
  ELSE
    RETURN FALSE
  ENDIF

ENDPROC

