OPT MODULE
OPT EXPORT

MODULE  'amigaguide',
        'libraries/amigaguide'

->  Procedura wywietlajca via amigaguide.library
->  IN :
->      filename  -> nazwa pliku
->      os        -> wersja biblioteki
->      screen    -> nazwa ekranu publicznego na ktrym ma pokaza
->
->  OUT :
->      success   -> udao si pokaza czyte nie
->

PROC guide(filename : PTR TO CHAR,os,screen = NIL)

  DEF success,
      file  [40]  : STRING,   -> nazwa pliku
      path  [256] : STRING,
      olddir[256] : STRING,
      cmd   [200] : STRING,   -> Komenda
      run   [512] : STRING,   -> Execute() string
      myg         : newamigaguide,
      pathlock

  amigaguidebase := OpenLibrary('amigaguide.library',os)

  IF amigaguidebase

    file    := FilePart(filename)
    success := InStr(filename,file)

    IF success > NIL                        -> sprawdzam czy filename jest ze sciek
      MidStr(path,filename,NIL,success)
      pathlock := Lock(path,OLDFILE)
    ELSE
      pathlock := NIL
    ENDIF

    success := GetCurrentDirName(olddir,256)

    myg.lock       := pathlock
    myg.pubscreen  := screen
    myg.name       := filename
    myg.screen     := NIL
    myg.hostport   := NIL
    myg.clientport := NIL
    myg.basename   := NIL
    myg.flags      := NIL
    myg.context    := NIL
    myg.extens     := NIL
    myg.client     := NIL
    myg.node       := NIL
    myg.line       := NIL

    success := OpenAmigaGuideA(myg,NIL)

    IF success
      CloseAmigaGuide(success)
    ELSE
      success := FALSE
    ENDIF
    IF pathlock THEN UnLock(pathlock)
    IF amigaguidebase THEN CloseLibrary(amigaguidebase)

  ELSE
    RETURN FALSE
  ENDIF

ENDPROC success

